#include "dbcon.h"
#include "common.h"
#define MAX_PATH 2048


void connect_db(MYSQL *conn) {

mysql_init(conn);

mysql_real_connect(conn,MYSQL_HOST,conf.mysql_id,conf.mysql_pw,conf.mysql_db,0,(char*)NULL,0);

printf("Connect DB!\n");


}

int user_check(MYSQL *conn,char *username) {
	printf("start user_check()\n");
	MYSQL_RES *res;
	MYSQL_ROW row;
	char query_buf[512];
	memset(query_buf,0x0,sizeof(query_buf));

	snprintf(query_buf,512,"select user_id from msghard_user");
	printf("%s\n",query_buf);	
	if(mysql_real_query(conn,query_buf,strlen(query_buf))!=0) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn)
);
                error_handling("mysql error");
	}
	
	res=mysql_store_result(conn);

	while((row = mysql_fetch_row(res))) {
		printf("db : user_id : %s\n",row[0]);
		
		if(strcmp(row[0],username)==0) {
			/* ̵  return 1 */
			return 1;
		}
	}
	printf("free()\n");
	mysql_free_result(res);
	
	return 0;


}


void db_user_add(MYSQL *conn,char *username) {
	printf("start db_user_add\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

	snprintf(query_buf,512,"insert into msghard_user values(\'%s\',sysdate(),sysdate(),%ld,%ld,%d)",username,conf.default_size,conf.default_size,0);

	if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
		printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
		error_handling("mysql error");
	}



}
void db_update_last_time(MYSQL *conn,char *username) {
	printf("start db_update_last_time\n");

        char query_buf[512];
        memset(query_buf,0x0,sizeof(query_buf));

        snprintf(query_buf,512,"update msghard_user set last_date=sysdate() where user_id=\'%s\'",username);

        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }

}
void db_insert_file(MYSQL *conn,char *username) {
        printf("start db_insert_file\n");

        char query_buf[512];
	char initial[50];
	memset(initial,0x0,50);
        memset(query_buf,0x0,sizeof(query_buf));
        strncpy(initial,file_queue[0].filename,50-3);
        initial[41]='.';
        initial[42]='.';
        initial[43]='\0';

	printf("insert check1\n");
	printf("%s\n",username);
	printf("%s\n",file_queue[0].filename);
	printf("%s\n",initial);
	printf("%s\n",file_queue[0].path);

        snprintf(query_buf,512,"insert into msghard_file values(NULL,\'%s\',\'%s\',\'%s\',%ld,sysdate(),0,\'%s\')",username,file_queue[0].filename,initial,file_queue[0].filesize,file_queue[0].path);
	printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }
	printf("return db\n");
}


void db_insert_dir(MYSQL *conn,char *username,char *dirname,char *present_path) {
        printf("start db_insert_file\n");

        char query_buf[512];
        char initial[50];
        memset(initial,0x0,50);
        memset(query_buf,0x0,sizeof(query_buf));
        strncpy(initial,dirname,50-3);
        initial[41]='.';
        initial[42]='.';
        initial[43]='\0';

        printf("insert check1\n");
        printf("%s\n",username);
        printf("%s\n",file_queue[0].filename);
        printf("%s\n",initial);
        printf("%s\n",file_queue[0].path);

        snprintf(query_buf,512,"insert into msghard_file values(NULL,\'%s\',\'%s\',\'%s\',%ld,sysdate(),1,\'%s\')",username,dirname,initial,0,present_path);
        printf("%s\n",query_buf);
        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }
        printf("return db\n");
}

void db_delete_dir_file(MYSQL *conn,char *username,char *filename,char *present_path) {
        printf("start db_delete_file\n");

        char query_buf[MAX_PATH];
        memset(query_buf,0x0,MAX_PATH);

        snprintf(query_buf,MAX_PATH,"delete from msghard_file where user_id=\'%s\' and locate=\'%s\'",username,present_path);

        if(mysql_real_query(conn,query_buf,strlen(query_buf))) {
                printf("error no : %d\n%s\n",mysql_errno(conn),mysql_error(conn));
                error_handling("mysql error");
        }

}

