#include "common.h"
#include "main.h"
#include "gnu_getpass.h"

#define MAX_PATH 2048

int main() {
	/* ȭ */
	daemonize();

	int m_state=0;
	int check=0;
	m_state=pthread_mutex_init(&mutx,NULL);
	if(m_state) {
		error_handling("mutx init failed\n");
	}


	loadconfig();		
	queue_ptr=-1;
	dn_flag=0;
	pub_ns_sock=0;	
	print_buf print;
	pub_print = &print;
	set_printbuf(&print);
	
        tcp_bind(conf.ip,conf.port,&pub_data_sock);

	pid_t pid;	
int sock,recv_len,i,state;
	int cm_recvsock,cm_sendsock,cd_sock;
	char *recv_tok[32]={NULL,};
	char *ip_port[2];
	char buf[MAX_BUF];
	char ch_sendbuf[MAX_BUF];
	char ch_recvbuf[MAX_BUF];	
	char add_user[256];
		
	memset(ch_sendbuf,0x0,sizeof(ch_sendbuf));
	memset(ch_recvbuf,0x0,sizeof(ch_recvbuf));
	
	struct sigaction act;
	act.sa_handler=z_handler;
	sigemptyset(&act.sa_mask);
	act.sa_flags=0;
	state=sigaction(SIGCHLD,&act,0);
	if(state!=0) {
		error_handling("sigaction() error");
	}
	unsigned char md5_buf[34];
	unsigned char tmp_mdbuf[34];
	unsigned char md_buf[34];
	msn_session session;
	session.trid=1;

	pub_session = &session;
	
		
	sock=msn_init_session(&session);
	//printf("return main()\n");
	pub_ns_sock = dup(sock);
	fcntl(sock, F_SETFL, 0);
	memset(buf,0x0,MAX_BUF);


	connect_db(&conn);
	int ping_state;
	pthread_t ping;
        ping_state =pthread_create(&ping,NULL,ping_pthread,(void *)&sock);
        if(ping_state!=0) {
                error_handling("thread create error!!");
        }


        change_nickname(&session,&sock);
	while(recv_len=recv(sock,buf,MAX_BUF,0)) {
	//printf("%s\n",buf);
	if(strncmp(buf, "RNG", 3)==0) {
		memset(recv_tok,0x0,sizeof(recv_tok));
		memset(user_id,0x0,sizeof(user_id));
		memset(add_user,0x0,sizeof(add_user));

                msn_strtok(buf,recv_tok);
                strncpy(user_id,recv_tok[5],sizeof(user_id));

		pid=fork();



		if(pid==0) {
			/* child process */

                //printf("user_id %s\n",add_user);

                strncpy(add_user,recv_tok[5],strlen(recv_tok[5]));
                check = user_check(&conn,add_user);
                //printf("check : %d\n",check);
                if(check == 0) {

                        db_user_add(&conn,add_user);
                        create_home(add_user);
                }
                else {
                }











			ip_port_tok(recv_tok[2],ip_port);
			cm_recvsock=tcp_connect(ip_port[0],atoi(ip_port[1]));
			cm_sendsock=dup(cm_recvsock);
			//shutdown(cm_recvsock,SHUT_WR);
			//shutdown(cm_sendsock,SHUT_RD);
			if(cm_sendsock==-1) error_handling("cm_sock error!!");
	snprintf(ch_sendbuf,MAX_BUF-1,"ANS %d %s %s %d\r\n",session.trid++,conf.msn_id,recv_tok[4],atoi(recv_tok[1]));
		//printf("check\n");	
			if(send(cm_sendsock,ch_sendbuf,strlen(ch_sendbuf),0)==-1) {
				error_handling("child send() error!!");
			}

			fcntl(cm_recvsock, F_SETFL, O_NONBLOCK);
			//printf("%s",ch_sendbuf);
			memset(ch_sendbuf,0x0,sizeof(ch_sendbuf));
			recv(cm_recvsock,ch_recvbuf,sizeof(ch_recvbuf),0);
			//printf("%s",ch_recvbuf);
			memset(buf,0x0,sizeof(buf));
			recv(cm_recvsock,ch_recvbuf,sizeof(ch_recvbuf),0);
			//printf("%s",ch_recvbuf);
			memset(buf,0x0,sizeof(ch_recvbuf));	
			fcntl(cm_recvsock, F_SETFL, 0);
			conv_server(&session,&cm_sendsock,&cm_recvsock,user_id,&print);
			
			close(cm_sendsock);	
			close(cm_recvsock);

			return 0;
		}
		else {

			memset(buf,0x0,sizeof(buf));
		
		}		

	}
	else if(strncmp(buf,"CHL",3)==0) {
		memset(recv_tok,0x0,sizeof(recv_tok));
		memset(tmp_mdbuf,0x0,sizeof(tmp_mdbuf));
		memset(md_buf,0x0,sizeof(md_buf));
		buf[strlen(buf)-2]='\0';
		msn_strtok(buf,recv_tok);
		snprintf(tmp_mdbuf,MAX_BUF-1,"%sQ1P7W2E4J9R8U3S5",recv_tok[2]);
		
		tmp_mdbuf[strlen(tmp_mdbuf)]='\0';
				
		MD5(tmp_mdbuf,strlen(tmp_mdbuf),md_buf);
		for(i=0; i<16; i++) {
			//printf("%02x",md_buf[i]);
        		snprintf(&md5_buf[i*2],strlen(md_buf),"%02x",md_buf[i]);
		}
		snprintf(buf,MAX_BUF-1,"QRY %d msmsgs@msnmsgr.com 32\r\n%s",session.trid++,md5_buf);		
		//printf("%s\n",buf);
		send(sock,buf,strlen(buf),0);	
	}
	else if(strncmp(buf,"ADC",3) == 0 || strncmp(buf,"ADD",3)==0 ) {
		//printf("::: %s",buf);
		memset(recv_tok,0x0,sizeof(recv_tok));
		memset(add_user,0x0,256);
		msn_strtok(buf,recv_tok);
		/* ϵ  : 1 ,  ȵǾ  : 0 */
	
		
	if(strncmp(recv_tok[2],"BL",2) !=0) {
		if((recv_tok[0],"ADD",3)==0) {
			/*   ϶ */
			//printf("user_id %s\n",add_user);
	                msn_user_add(&session,&sock,add_user);
 
			strncpy(add_user,recv_tok[3],strlen(recv_tok[3]));
			
			/*  ϵ  üũ */
			check = user_check(&conn,add_user);
			//printf("ADD check : %d\n",check);
                        if(check == 0) {
				
                                /*  ȵǾ  */
                                db_user_add(&conn,add_user);
				create_home(add_user);
				/* MSN ģ */
				//msn_remove_user(session,&sock,add_user);
                        }
                        else {
                                /*  Ǿ */
                        }

			

		}
		else {
			/* ι ̻  ϶ */
			strncpy(add_user,&recv_tok[3][2],strlen(recv_tok[3])-2);
	                msn_user_add(&session,&sock,add_user);
			//printf("user_id %s\n",add_user);
			/*  ϵ  üũ */
			check = user_check(&conn,add_user);
			printf("check : %d\n",check);
			if(check == 0) {
				/*  ȵǾ  */
				db_user_add(&conn,add_user);
				create_home(add_user);

			}

			else {
				/*  Ǿ */
			}


		}
		printf("user_id : %s\n",add_user);
	}
		/* ϵ  üũ 
		   ϰ 1 = ϵǾ.
		   ϰ 2 =  .
		*/
		//user_register(&conn,recv_tok[3]);
		/*msn_strtok(buf,recv_tok);

		if(recv_buf[2],RL 	
		*/
	}
	}
	memset(buf,0x0,MAX_BUF);
	mysql_close(&conn);
		
}

void change_nickname(msn_session *session,int *sock) {
	char send_buf[MAX_BUF];
	char u_send_buf[MAX_BUF];
	memset(send_buf,0x0,MAX_BUF);
	memset(u_send_buf,0x0,MAX_BUF);
	printf("%s\n",conf.nick_name);
        char nick[256];

        char nick_ret[256];
	memset(nick,0x0,256);
	memset(nick_ret,0x0,256);
	strncpy(nick,conf.nick_name,strlen(conf.nick_name));
        //url_encode(nick,nick_ret,strlen(nick_ret));
	//url_decode(nick);
	

	snprintf(send_buf,MAX_BUF,"PRP %d MFN %s\r\n",session->trid++,nick);


	printf("%s\n",send_buf);
        msn_ic[0] = msn_ic[1] = (iconv_t) -1;
        msn_ic[0] = iconv_open("EUC-KR","UTF-8");
        msn_ic[1] = iconv_open("UTF-8", "EUC-KR");
        utf8encode(msn_ic[1],send_buf , u_send_buf,MAX_BUF*2);

	if(send(*sock,u_send_buf,strlen(u_send_buf),0)==-1) {
		error_handling("send error");
	}
	memset(send_buf,0x0,MAX_BUF);
	printf("s %s\n",u_send_buf);
/*        if(recv(*sock,send_buf,MAX_BUF,0)==-1) {
                error_handling("send error");
        }
	printf("r %s\n",send_buf);
*/


}

void daemonize() {
	int i;
	printf("Daemon started..\n");
	if (fork() != 0)
		exit(0);
	setsid();
	signal(SIGHUP, SIG_IGN);
	if (fork() != 0)         
	exit(0);     
	chdir("/");     
	umask(0);     
}

void create_home(char *username) {
	printf("start create_home()\n");
	char create_home[strlen(conf.msghard_home) + strlen(username)+3];

	snprintf(create_home,sizeof(create_home),"%s/%s",conf.msghard_home,username);

	printf("home : %s\n",create_home);
	mkdir(create_home,0700);
}

void msn_user_add(msn_session *session,int *sock,char *username) {
// ADC 211 AL N=testmsghard1@hotmail.com
	printf("start msn_user_add()\n");
	char send_buf[MAX_BUF];
	char recv_buf[MAX_BUF];
	memset(send_buf,0x0,MAX_BUF);
	memset(recv_buf,0x0,MAX_BUF);
	snprintf(send_buf,MAX_BUF,"ADC %d AL N=%s\r\n",session->trid++,username);

        if(send(*sock,send_buf,strlen(send_buf),0)==-1) {
                 error_handling("cm_sendsock error!!");
        }
        if(recv(*sock,recv_buf,MAX_BUF,0)==-1) {
                 error_handling("cm_recvsock error!!");
        }

	
		
}

void msn_remove_user(msn_session *session,int *sock,char *username) {

// REM 15 FL 1 cho_hyunho@hotmail.com
	char remove_buf[MAX_BUF];
	memset(remove_buf,0x0,MAX_BUF);
	snprintf(remove_buf,MAX_BUF,"REM %d FL 1 %s\r\n",session->trid++,username);

        if(send(*sock,remove_buf,strlen(remove_buf),0)==-1)
        {
                 error_handling("cm_sendsock error!!");
        }




}
void *ping_pthread(void *sock) {

	int *ping_sock = (int *)sock;	
	char ping_buf[16];
	memset(ping_buf,0x0,16);
	snprintf(ping_buf,16,"PNG\r\n");
	int send_num=0;	
	int count=1;
	while(1) {
		sleep(10);
	
	//	printf("count : %d\n",count++);	
		send_num=send(*ping_sock,ping_buf,strlen(ping_buf),0);

	}
}


void *typinguser_pthread(void *sock) {
        int *ping_sock = (int *)sock;
        int send_num=0;
	char type_buf[MAX_BUF];
	char type_message[MAX_BUF];
	memset(type_buf,0x0,MAX_BUF);
	memset(type_message,0x0,MAX_BUF);

	snprintf(type_message,MAX_BUF,"MIME-Version: 1.0\r\nContent-Type: text/x-msmsgscontrol\r\nTypingUser: %s\r\n\r\n\r\n",conf.msn_id);
        while(1) {
		memset(type_buf,0x0,MAX_BUF);
		printf("typing\n");
		snprintf(type_buf,MAX_BUF,"MSG %d U %d\r\n%s",pub_session->trid++,strlen(type_message),type_message);
				
                send_num=send(*ping_sock,type_buf,strlen(type_buf),0);
		sleep(10);
        }



}


void conv_server(msn_session *session,int *cm_sendsock,int *cm_recvsock,char *user_id,print_buf *print) {


/*  */

	db_update_last_time(&conn,user_id);


	int typing_user_state;
        pthread_t typing;
        typing_user_state =pthread_create(&typing,NULL,typinguser_pthread,(void *)cm_sendsock);
        if(typing_user_state!=0) {
                error_handling("thread create error!!");
        }


	pub_tree_ptr=0;
	pub_file_ptr=1;
	const char *c_message;
	const char *c_u_e_message_ptr;
	const char *c_e_u_message_ptr;
	char *u_e_message_ptr;
	char *e_u_message_ptr;
	pub_head=NULL;
	list_file *p;
	p=NULL;
	int total_page,present_page;
	total_page=present_page = 0;

	int dir_ptr;
	int max_count=0;

	memset(pub_present_path,0x0,MAX_PATH);
	
	snprintf(pub_present_path,MAX_PATH,"%s/%s",conf.msghard_home,user_id);
	pub_head = get_list_file(pub_present_path,&pub_max_count);	

	char send_buf[MAX_BUF];
	char recv_buf[MAX_BUF];
	char u_send_buf[1500];
	char u_send_buf1[MAX_BUF];
	char u_recv_buf[MAX_BUF];
	char u_message[MAX_BUF];
	char u_message1[MAX_BUF];
	char e_message[MAX_BUF];
	char *u_send_ptr;
	char *u_send_ptr1;
	char *recv_ptr;
	char *tmp_recv_ptr;	
	char recv_message[512];
	char send_message[512];
	char *msg_tok[64]={NULL,};
	char *msg_message_tok[2];
	char *msg_file_tok[5] = {NULL,};
	const char *c_format;
	char *format_ptr;
	int cookie=0;	

	char format[]="X-MMS-IM-Format: FN=%EA%B5%B4%EB%A6%BC%EC%B2%B4; EF=; CO=0; CS=81; PF=0";
	char format_ret[80];
	url_encode(format, format_ret, strlen(format_ret));

	char message[256];
	char *send_message_ptr;
	char tmp_buf[64];
        char *extra_tok[32]={NULL,};


	int buf_len=0;
	int i;
	pthread_t file;
	pthread_state=-1;
	memset(message,0x0,sizeof(message));
	memset(send_buf,0x0,sizeof(send_buf));
        memset(u_recv_buf,0x0,sizeof(u_recv_buf));
	c_message =" ";
	
	

	memset(u_send_buf,0x0,sizeof(u_send_buf));
	memset(u_send_buf1,0x0,MAX_BUF);
	p=pub_head;
		
        set_send_message(session,pub_head,p,u_send_buf,u_send_buf1,u_send_ptr1,pub_max_count,pub_file_ptr,pub_present_path,print,format);
	while(p=p->Next) {
		p->data.filename[strlen(p->data.filename)]='\0';

        }
        p=pub_head;

	if(send(*cm_sendsock,u_send_buf,strlen(u_send_buf),0)==-1)
        {
                 error_handling("cm_sendsock error!!");
        }



        if(send(*cm_sendsock,u_send_buf1,strlen(u_send_buf1),0)==-1)
        {
                 error_handling("cm_sendsock error!!");
        }



	while(1) {
		memset(msg_tok,0x0,sizeof(msg_tok));
		memset(send_buf,0x0,MAX_BUF);
		memset(u_recv_buf,0x0,sizeof(u_recv_buf));	
		memset(recv_buf,0x0,MAX_BUF);
		memset(u_send_buf,0x0,MAX_BUF);
		u_send_ptr=NULL;
		recv_ptr=NULL;
		tmp_recv_ptr=NULL;
			
		if(!(recv(*cm_recvsock,u_recv_buf,sizeof(u_recv_buf),0))) {
			error_handling("recv error!!");
		}

		if(strncmp(u_recv_buf,"BYE",3)==0) {
			snprintf(tmp_buf,64,"BYE %s\r\n",user_id);
			
			printf("BYE???\n");
			printf("%s\n",u_recv_buf);
			if(strncmp(recv_buf,tmp_buf,4+(strlen(user_id)))) {
				pthread_cancel(typing);
				return ;
			
			}

			
		}
		
		if(strncmp(u_recv_buf,"MSG",3)==0) {
			printf("󰡿 \n");
			memset(msg_tok,0x0,sizeof(msg_tok));
			msn_strtok_null(u_recv_buf,msg_tok);
		
			if(strncmp(msg_tok[3],"X-MMS-IM-Format",15)==0) {
				printf("޼\n");
				memset(send_buf,0x0,MAX_BUF);
				memset(recv_message,0x0,sizeof(recv_message));	
				
				msg_tok[4][strlen(msg_tok[4])]='\n';	
			
					int len=0;
				len=strlen(msg_tok[4]);
				char tmp_buf[MAX_BUF];
				memset(tmp_buf,0x0,MAX_BUF);
				strncpy(tmp_buf,msg_tok[4],strlen(msg_tok[4]));
				
				char recv_buffer[strlen(msg_tok[4])];
				memset(recv_buf,0x0,sizeof(recv_buf));
				c_u_e_message_ptr=NULL;
				c_u_e_message_ptr=msg_tok[4];
				u_e_message_ptr=NULL;
				u_e_message_ptr=utf8_to_euckr(c_u_e_message_ptr);
				c_u_e_message_ptr=NULL;
				msn_strtok_n(u_e_message_ptr,msg_message_tok);	
				strncpy(recv_message,u_e_message_ptr,strlen(msg_message_tok[0]));
    				memset(msg_tok[4],0x0,sizeof(msg_tok[4]));
				memset(msg_message_tok,0x0,sizeof(msg_message_tok));
				free(u_e_message_ptr);
				u_e_message_ptr=NULL;
				printf("recv message : %s\r\n",recv_message);
			//=================================
		

	/* ================= ޼ ó ================= */
	message_process(pub_head,recv_message,&pub_max_count,&pub_file_ptr,pub_present_path,&pub_tree_ptr,session,cm_recvsock,cm_sendsock,&file,print);

	memset(u_send_buf,0x0,sizeof(u_send_buf));
	memset(u_send_buf1,0x0,sizeof(u_send_buf1));
	set_send_message(session,pub_head,p,u_send_buf,u_send_buf1,u_send_ptr1,pub_max_count,pub_file_ptr,pub_present_path,print,format);

	if(send(*cm_sendsock,u_send_buf,strlen(u_send_buf),0)==-1)
        {
                 error_handling("cm_sendsock error!!");
        }




        if(send(*cm_sendsock,u_send_buf1,strlen(u_send_buf1),0)==-1)
        {
                 error_handling("cm_sendsock error!!");
        }


	/* ================= ޼ ó ================= */



	
				c_e_u_message_ptr=recv_message;	
				e_u_message_ptr=NULL;
				e_u_message_ptr=euckr_to_utf8(c_e_u_message_ptr);
				c_e_u_message_ptr=NULL;
				strncpy(send_message,e_u_message_ptr,strlen(e_u_message_ptr));
				free(e_u_message_ptr);

				memset(send_message,0x0,sizeof(send_message));
			
			
					

			}
			else if(msg_tok[7]!=NULL) {
				printf("check file\n");
				if(strncmp(msg_tok[7],"Application-File:",17)==0) {
					printf("FILE RECV!!");
					printf("msg_tok[7] %s\n[9] %s\n",msg_tok[7],msg_tok[9]);
					file_trans(pub_head,msg_tok,"RECV",cm_sendsock,cm_recvsock,session,&file,pub_present_path,0,pub_tree_ptr);	

					if(msg_tok[14] != NULL) {		
						memset(extra_tok,0x0,sizeof(extra_tok));
						extra_tok[0] = msg_tok[9];
                                                extra_tok[1] = msg_tok[10];
                                                extra_tok[2] = msg_tok[11];
                                                extra_tok[3] = msg_tok[12];
                                                extra_tok[4] = msg_tok[13];
                                                extra_tok[5] = msg_tok[14];
                                                extra_tok[6] = msg_tok[15];
                                                extra_tok[7] = msg_tok[16];
                                                extra_tok[8] = msg_tok[17];
							
						file_trans(pub_head,extra_tok,"RECV",cm_sendsock,cm_recvsock,session,&file,pub_present_path,0,pub_tree_ptr);

					}
                                        if(msg_tok[21] != NULL) {
                                                memset(extra_tok,0x0,sizeof(extra_tok));
                                                extra_tok[0] = msg_tok[18];
                                                extra_tok[1] = msg_tok[19];
                                                extra_tok[2] = msg_tok[20];
                                                extra_tok[3] = msg_tok[21];
                                                extra_tok[4] = msg_tok[22];
                                                extra_tok[5] = msg_tok[23];
                                                extra_tok[6] = msg_tok[24];
                                                extra_tok[7] = msg_tok[25];
                                                extra_tok[8] = msg_tok[26];

                                                file_trans(pub_head,extra_tok,"RECV",cm_sendsock,cm_recvsock,session,&file,pub_present_path,0,pub_tree_ptr);

                                        }
                                        if(msg_tok[28] != NULL) {
                                                memset(extra_tok,0x0,sizeof(extra_tok));
                                                extra_tok[0] = msg_tok[27];
                                                extra_tok[1] = msg_tok[28];
                                                extra_tok[2] = msg_tok[29];
                                                extra_tok[3] = msg_tok[30];
                                                extra_tok[4] = msg_tok[31];
                                                extra_tok[5] = msg_tok[32];
                                                extra_tok[6] = msg_tok[33];
                                                extra_tok[7] = msg_tok[34];
                                                extra_tok[8] = msg_tok[35];

                                                file_trans(pub_head,extra_tok,"RECV",cm_sendsock,cm_recvsock,session,&file,pub_present_path,0,pub_tree_ptr);

                                        }
                                        if(msg_tok[35] != NULL) {
						printf("msg_tok[35]\n");
                                                memset(extra_tok,0x0,sizeof(extra_tok));
                                                extra_tok[0] = msg_tok[36];
                                                extra_tok[1] = msg_tok[37];
                                                extra_tok[2] = msg_tok[38];
                                                extra_tok[3] = msg_tok[39];
                                                extra_tok[4] = msg_tok[40];
                                                extra_tok[5] = msg_tok[41];
                                                extra_tok[6] = msg_tok[42];
                                                extra_tok[7] = msg_tok[43];
                                                extra_tok[8] = msg_tok[44];

                                                file_trans(pub_head,extra_tok,"RECV",cm_sendsock,cm_recvsock,session,&file,pub_present_path,0,pub_tree_ptr);

                                        }


				}

				

			}
			else if(strncmp(msg_tok[3],"Invitation-Command: CANCEL",26) == 0 ) {
				printf("  \n");
				char c_cookie[12];
				memset(c_cookie,0x0,12);
				cookie=0;
				strncpy(c_cookie,&msg_tok[4][19],strlen(msg_tok[4]) - 19);
				cookie = atol(c_cookie);
				printf("cookie : %ld\n",cookie);
				del_queue(cookie);
	

			}
			
		printf("\nend while\n");

		}
		
		memset(send_buf,0x0,MAX_BUF);
		send_message_ptr=NULL;
	}
	printf("while error\n");
	
}

void z_handler(int sig) {
	pid_t pid;
	int rtn;
	while((pid=waitpid(-1,&rtn,WNOHANG))>0) {

		printf("child process %d exit..\n",pid);
	}
}

void set_send_message(msn_session *session,list_file *head,list_file *p,char *u_send_buf,char *u_send_buf1,char *u_send_ptr1,int max_count,int file_ptr ,char *present_path,print_buf *print,char *tmp_format) {
	printf("\nset send message \n");
	char format[80];
	memset(format,0x0,sizeof(format));
	strncpy(format,tmp_format,strlen(tmp_format));
	char *c_send_buf_ptr=NULL;
	char *u_send_buf_ptr=NULL;
	//int max_count = *t_max_count;
	char message[MAX_BUF];
	char u_message[MAX_BUF];
	memset(message,0x0,MAX_BUF);
	memset(u_message,0x0,MAX_BUF);
	char file_char[100];
	char file_list[MAX_BUF];
	memset(file_list,0x0,MAX_BUF);
	char u_sendbuf_ptr;
	char tmp_present_path[MAX_PATH];	
	char path[65];	
	int i;
	memset(path,0x0,sizeof(path));
	memset(tmp_present_path,0x0,MAX_PATH);
	char tmp_path[MAX_PATH] = ">> ";
	char *path_tok[256]={"\0",};
		
	memset(path_tok,0x0,sizeof(path_tok));	
	strncpy(tmp_present_path,present_path,strlen(present_path));

	
	msn_strtok_path(tmp_present_path,path_tok);
i=0;
	while(path_tok[i]) {
		i++;
	}
	int j=0;
	int flag=0;
	p=head;	
	i=0;
	while(path_tok[i+1]) {
		if(strcmp(user_id, path_tok[i])==0 || flag==1 ) {
			
			flag=1;
			strcat(tmp_path," > ");
			strcat(tmp_path,path_tok[i+1]);
			
			
	
		}
		i++;
	
	}	


	if(strlen(tmp_path) > 65 ) {
		for(i=strlen(tmp_path)-65;i<strlen(tmp_path);i++) {
			path[j++] = tmp_path[i];
		}
		path[0] ='.';
		path[1] ='.';

	}
	else {
		strncpy(path,tmp_path,sizeof(path));
	}
	
	
	p=head;
	flag=0;
	i=1;


	while(p=p->Next) {
		p->data.list_num=0;
		if((flag==1 || p->data.count == file_ptr) &&  i<=10 ) {
			
			flag=1;
			if(p->data.isdir == 1) { 
				p->data.list_num=i;
				snprintf(file_char,100," %2d    %-45s\n     []  %s\r\n",i++,p->data.initial,p->data.date);
			}
			else if(p->data.isdir==0){ 

			//	printf("i\n"); 
				p->data.list_num=i;
                                snprintf(file_char,100," %2d      %-45s\n  %6.1f %s  %s\r\n",i++,p->data.initial,p->data.size,p->data.unit,p->data.date);
	
			}
			else {
				p->data.list_num=0;
			}	
				
			
		
		strcat(file_list,file_char);
		memset(file_char,0x0,sizeof(file_char));
		
		}
	}



	
	memset(message,0x0,MAX_BUF);	


	snprintf(message,MAX_BUF,"%s\r\n%s\r\n------------------------------ [ Page %2d/%-2d ] ------------------------------\r\n%s",path,print->header,(file_ptr/10)+1,(max_count/10)+1,file_list);
        const char *c_buf_ptr;
	char *message_tok[32];
	memset(message_tok,0x0,sizeof(message_tok));

        c_send_buf_ptr = message;

	message[strlen(message)] = '\n';

	

	int max_message_len=0;
	msn_ic[0] = msn_ic[1] = (iconv_t) -1;
        msn_ic[0] = iconv_open("EUC-KR","UTF-8");
        msn_ic[1] = iconv_open("UTF-8", "EUC-KR");
	utf8encode(msn_ic[1], c_send_buf_ptr, u_message, 2*MAX_BUF);


	for(i; i<=10;i++) {

                snprintf(file_char,100,"\r\n");
                strcat(u_message,file_char);
                memset(file_char,0x0,sizeof(file_char));

        }
	strcat(u_message,"----------------------------------------------------------------------------");


	i=1;
	p=head;

	snprintf(u_send_buf,1500,"MSG %d N %d\r\nMIME-Version: 1.0\r\nContent-Type: text/plain; charset=UTF-8\r\n%s\r\n\r\n%s",0,(strlen(format)+strlen(u_message)+64),format,u_message);
		


	if(max_count <= 10 ) { 
                //printf("solo page\n");
                snprintf(u_send_buf1,MAX_BUF,"MSG %d N %d\r\nMIME-Version: 1.0\r\nContent-Type: text/plain; charset=UTF-8\r\n%s\r\n\r\n%s",session->trid++,(strlen(format)+strlen(print->u_s_tailer)+64),format,print->u_s_tailer);
		//printf("last : %s\n",u_send_buf1);
        }

	else if(file_ptr == 1) { 
		//printf("first page\n");

		snprintf(u_send_buf1,MAX_BUF,"MSG %d N %d\r\nMIME-Version: 1.0\r\nContent-Type: text/plain; charset=UTF-8\r\n%s\r\n\r\n%s",session->trid++,(strlen(format)+strlen(print->u_f_tailer)+64),format,print->u_f_tailer);

		//printf("last : %s\n",u_send_buf1);
	}
	else if((file_ptr+10) > max_count ) { 
		//printf("last page\n");
		snprintf(u_send_buf1,MAX_BUF,"MSG %d N %d\r\nMIME-Version: 1.0\r\nContent-Type: text/plain; charset=UTF-8\r\n%s\r\n\r\n%s",session->trid++,(strlen(format)+strlen(print->u_l_tailer)+64),format,print->u_l_tailer);		
	}
	else {  
		//printf("mid page\n");
		snprintf(u_send_buf1,MAX_BUF,"MSG %d N %d\r\nMIME-Version: 1.0\r\nContent-Type: text/plain; charset=UTF-8\r\n%s\r\n\r\n%s",session->trid++,(strlen(format)+strlen(print->u_m_tailer)+64),format,print->u_m_tailer);

	}	



}

